<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player.html">mediaPlayer</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player_1_1android.html">android</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_android_s_l_e_s_media_queue_8h_source.html">AndroidSLESMediaQueue.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:afdfda08735cf877ed378547a19fadef7"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">QueueEvent</a> { <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7abb1ca97ec761fc37101737ba0aa2e7c5">QueueEvent::ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7ad5ccba9de88aaed377f309401e79ca0d">QueueEvent::FINISHED_READING</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7aa29397782518e32fb22630b8d2ad5dc5">QueueEvent::FINISHED_PLAYING</a>
 }</td></tr>
<tr class="memdesc:afdfda08735cf877ed378547a19fadef7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Represent the event types that will be sent to the <code>StatusCallback</code> when the queue change state.  <a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">More...</a><br /></td></tr>
<tr class="separator:afdfda08735cf877ed378547a19fadef7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c3070e9a966b7e96caf25695b108ab5"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a7c3070e9a966b7e96caf25695b108ab5">Byte</a> = <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html#a61064239f4eac92ed319f90ec93aa3df">DecoderInterface::Byte</a></td></tr>
<tr class="separator:a7c3070e9a966b7e96caf25695b108ab5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf7e7bc636b84e92b72c25a50849ca0f"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> = std::function&lt; void(<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">QueueEvent</a> event, const std::string &amp;reason)&gt;</td></tr>
<tr class="separator:aaf7e7bc636b84e92b72c25a50849ca0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a12dfd7dff881e60a525ed0854f7ae39f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a12dfd7dff881e60a525ed0854f7ae39f">onBufferFree</a> ()</td></tr>
<tr class="separator:a12dfd7dff881e60a525ed0854f7ae39f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ca5ad828939b3fe46cd73e241b5ad5a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a5ca5ad828939b3fe46cd73e241b5ad5a">~AndroidSLESMediaQueue</a> ()</td></tr>
<tr class="separator:a5ca5ad828939b3fe46cd73e241b5ad5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3630e3478b4335d02393ea1de1c4f736"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3630e3478b4335d02393ea1de1c4f736">getNumBytesBuffered</a> () const</td></tr>
<tr class="separator:a3630e3478b4335d02393ea1de1c4f736"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef60ddab6a82c084f61e77e0a6ea7f5b"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aef60ddab6a82c084f61e77e0a6ea7f5b">getNumBytesPlayed</a> () const</td></tr>
<tr class="separator:aef60ddab6a82c084f61e77e0a6ea7f5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ae6ee5c6f3d2dfdca3f25ca879e05b0ae"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#ae6ee5c6f3d2dfdca3f25ca879e05b0ae">create</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">applicationUtilities::androidUtilities::AndroidSLESObject</a> &gt; queueObject, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html">DecoderInterface</a> &gt; decoder, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> onStatusChanged, const <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">PlaybackConfiguration</a> &amp;playbackConfiguration)</td></tr>
<tr class="separator:ae6ee5c6f3d2dfdca3f25ca879e05b0ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a663c2c715b7a0d980c24db4d294e4fee"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a663c2c715b7a0d980c24db4d294e4fee">NUMBER_OF_BUFFERS</a> {4u}</td></tr>
<tr class="memdesc:a663c2c715b7a0d980c24db4d294e4fee"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of buffers to use.  <a href="#a663c2c715b7a0d980c24db4d294e4fee">More...</a><br /></td></tr>
<tr class="separator:a663c2c715b7a0d980c24db4d294e4fee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cd17788f1d11c1130641b5efa2e852c"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3cd17788f1d11c1130641b5efa2e852c">BUFFER_SIZE</a> {131072u}</td></tr>
<tr class="memdesc:a3cd17788f1d11c1130641b5efa2e852c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Buffer size for the decoded data. This has to be big enough to be used with the decoder.  <a href="#a3cd17788f1d11c1130641b5efa2e852c">More...</a><br /></td></tr>
<tr class="separator:a3cd17788f1d11c1130641b5efa2e852c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Class responsible for reading raw audio from a decoder and feeding it to the underlying media player queue.</p>
<p class="">For that, the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a></code> has a parallel job that: 1- Fill its unused buffers with raw audio by calling the decoder <code>read</code> function. 2- Enqueue the buffers into the OpenSL ES media player queue. 3- Wait until the media queue finishes playing one of the buffers. 4- Once the media player is done with a buffer, it calls <code>onBufferFree</code>. 5- The <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a></code> mark the buffer as unused and go back to 1. </p>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a7c3070e9a966b7e96caf25695b108ab5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7c3070e9a966b7e96caf25695b108ab5">&#9670;&nbsp;</a></span>Byte</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a7c3070e9a966b7e96caf25695b108ab5">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::Byte</a> =  <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html#a61064239f4eac92ed319f90ec93aa3df">DecoderInterface::Byte</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aaf7e7bc636b84e92b72c25a50849ca0f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf7e7bc636b84e92b72c25a50849ca0f">&#9670;&nbsp;</a></span>EventCallback</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::EventCallback</a> =  std::function&lt;void(<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">QueueEvent</a> event, const std::string&amp; reason)&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Callback method signature called by the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a></code> when there is a queue event.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">event</td><td>The event that has occurred. </td></tr>
    <tr><td class="paramname">reason</td><td>A description of what triggered the error. It can be an empty string depending on the event triggered. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="afdfda08735cf877ed378547a19fadef7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afdfda08735cf877ed378547a19fadef7">&#9670;&nbsp;</a></span>QueueEvent</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::QueueEvent</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Represent the event types that will be sent to the <code>StatusCallback</code> when the queue change state. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="afdfda08735cf877ed378547a19fadef7abb1ca97ec761fc37101737ba0aa2e7c5"></a>ERROR&#160;</td><td class="fielddoc"><p class="">Sent when the queue encountered an unrecoverable error. </p>
</td></tr>
<tr><td class="fieldname"><a id="afdfda08735cf877ed378547a19fadef7ad5ccba9de88aaed377f309401e79ca0d"></a>FINISHED_READING&#160;</td><td class="fielddoc"><p class="">Sent when there is no more input data to feed the player. </p>
</td></tr>
<tr><td class="fieldname"><a id="afdfda08735cf877ed378547a19fadef7aa29397782518e32fb22630b8d2ad5dc5"></a>FINISHED_PLAYING&#160;</td><td class="fielddoc"><p class="">Sent when all buffers are free and playing is over. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5ca5ad828939b3fe46cd73e241b5ad5a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5ca5ad828939b3fe46cd73e241b5ad5a">&#9670;&nbsp;</a></span>~AndroidSLESMediaQueue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::~AndroidSLESMediaQueue </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae6ee5c6f3d2dfdca3f25ca879e05b0ae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae6ee5c6f3d2dfdca3f25ca879e05b0ae">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a> &gt; alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::create </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">applicationUtilities::androidUtilities::AndroidSLESObject</a> &gt;&#160;</td>
          <td class="paramname"><em>queueObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html">DecoderInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>decoder</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a>&#160;</td>
          <td class="paramname"><em>onStatusChanged</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">PlaybackConfiguration</a> &amp;&#160;</td>
          <td class="paramname"><em>playbackConfiguration</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a new <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a></code> object.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queueObject</td><td>The AndroidSLESObject that represent the OpenSL ES queue. </td></tr>
    <tr><td class="paramname">decoder</td><td>The decoder object used to get raw audio. </td></tr>
    <tr><td class="paramname">onStatusChanged</td><td>A function object that should point to a valid callback function called whenever the queue state changes. </td></tr>
    <tr><td class="paramname">playbackConfiguration</td><td>The playback configuration parameters. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the new object if object could be successfully created; otherwise, return a <code>nullptr</code>. </dd></dl>

</div>
</div>
<a id="a3630e3478b4335d02393ea1de1c4f736"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3630e3478b4335d02393ea1de1c4f736">&#9670;&nbsp;</a></span>getNumBytesBuffered()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::getNumBytesBuffered </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Get number of bytes that is currently queued.</p>
<dl class="section return"><dt>Returns</dt><dd>The number of bytes currently queued. </dd></dl>

</div>
</div>
<a id="aef60ddab6a82c084f61e77e0a6ea7f5b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef60ddab6a82c084f61e77e0a6ea7f5b">&#9670;&nbsp;</a></span>getNumBytesPlayed()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::getNumBytesPlayed </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Get number of bytes that has been played so far since this object was created.</p>
<dl class="section return"><dt>Returns</dt><dd>The number of bytes played so far. </dd></dl>

</div>
</div>
<a id="a12dfd7dff881e60a525ed0854f7ae39f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12dfd7dff881e60a525ed0854f7ae39f">&#9670;&nbsp;</a></span>onBufferFree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::onBufferFree </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">The callback function to be called when the media player is no longer reading from a buffer.</p>
<dl class="section warning"><dt>Warning</dt><dd>: This function should not lock or have any heavy processing because it is called from the media player thread. It should also avoid logging statements. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a3cd17788f1d11c1130641b5efa2e852c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3cd17788f1d11c1130641b5efa2e852c">&#9670;&nbsp;</a></span>BUFFER_SIZE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::BUFFER_SIZE {131072u}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Buffer size for the decoded data. This has to be big enough to be used with the decoder. </p>

</div>
</div>
<a id="a663c2c715b7a0d980c24db4d294e4fee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a663c2c715b7a0d980c24db4d294e4fee">&#9670;&nbsp;</a></span>NUMBER_OF_BUFFERS</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::NUMBER_OF_BUFFERS {4u}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The number of buffers to use. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/include/AndroidSLESMediaPlayer/<a class="el" href="_android_s_l_e_s_media_queue_8h_source.html">AndroidSLESMediaQueue.h</a></li>
<li>/workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/src/<a class="el" href="_android_s_l_e_s_media_queue_8cpp.html">AndroidSLESMediaQueue.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
